import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.*;  
import java.io.*; 
import java.nio.*;
import java.util.*;  
import java.lang.*;  
import java.nio.ByteBuffer;
import java.nio.channels.AsynchronousServerSocketChannel;
import java.nio.channels.AsynchronousSocketChannel;
import java.net.InetSocketAddress;
import java.nio.channels.CompletionHandler;
import java.nio.channels.*;
import java.awt.Rectangle;

public class Communicator
{   
    private int removeIndexFromList;
    private ArrayList<HeroStats> list = new ArrayList<HeroStats>();
    private ArrayList<Rectangle> mapList = new ArrayList<Rectangle>();
    private ArrayList<Shot> shotList = new ArrayList<Shot>();
    private ArrayList<Shot> shotList2 = new ArrayList<Shot>();
    private ArrayList<Shot> incommingShotList = new ArrayList<Shot>();
    private ArrayList<SocketAddress> listSocketAddress = new ArrayList<SocketAddress>();

    private Socket socket = null;
    private DatagramSocket dsoc;

    private int numberOfPlayers = -1;
    private ServerSocket ss = null;
    private final Communicator c = this;
    private boolean newClient;
    private HeroStats stat = new HeroStats();
    private HeroStats pokus = new HeroStats();
    private int SHOT_SPEED = 10;
    private int idOfShot;

    private final Communicator communicator = this;

    public Communicator()
    {
        establishConnection2();
    }

    public void establishConnection2()
    {
        loadMap();
        refresh();
        try
        {
            dsoc = new DatagramSocket(4445); 
        }
        catch(IOException e)
        {
            e.printStackTrace();
            System.out.println("Server error");
        }
        receive();
        send();

    }

    public void establishConnection()
    {
        loadMap();
        refresh();

        try
        {
            ss = new ServerSocket(4445);            
        }
        catch(IOException e)
        {
            e.printStackTrace();
            System.out.println("Server error");
        }
        while(true)
        {
            try
            {
                socket = ss.accept();
                socket.setTcpNoDelay(true);
                socket.setSoTimeout(2147483647);
                numberOfPlayers++;
                receive();
                send();
                System.out.println("connection Established");
            }
            catch(Exception e)
            {
                e.printStackTrace();
                System.out.println("Connection Error");
            }
        }
    }

    public void refresh()
    {
        Thread thread = new Thread()
            {
                public void run() 
                {
                    while(true)
                        try
                        { 
                            shotMove();
                            checkShotCollisions();
                            Thread.sleep(20);
                        }
                        catch(Exception e)
                        {
                            System.out.println(e);
                    }

                } 
            };
        thread.start();
    }

    public void receive()
    {
        Thread thread = new Thread()
            {
                public void run()
                {
                    boolean stop = false;
                    while(!stop)
                    {

                        byte buffer[] = new byte[4096];
                        DatagramPacket dpack = new DatagramPacket(buffer,buffer.length);
                        ObjectInput in = null;
                        ByteArrayInputStream bis = null;
                        try
                        {
                            //System.out.println("PRJIMAM NECO?");
                            dsoc.receive(dpack);
                            //System.out.println("ANO");
                            bis = new ByteArrayInputStream(buffer);
                            in = new ObjectInputStream(bis);
                            stat = (HeroStats)(in.readObject());
                            incommingShotList = (ArrayList<Shot>)(in.readObject()); 

                            for(Shot s : incommingShotList)
                            {
                                s.serverId = idOfShot;
                                shotList.add(s);
                                idOfShot++;
                            }
                           
                        }
                        catch(IOException e)
                        {
                            e.printStackTrace();
                            System.out.println(e+" Receive IO error");
                            stop = true;
                        }
                        catch(Exception e)
                        {
                            System.out.println(e+" chyba je v receive");
                            stop = true;
                        }
                        boolean idFound = false;

                        synchronized(list)
                        {
                            for(int i = 0; i < list.size(); i++)
                            {
                                if(list.get(i).id == stat.id)
                                {
                                    stat.health = list.get(i).health;
                                    list.set(i, stat);
                                    idFound = true;
                                }
                            }
                            if(!idFound)
                            {
                                //System.out.println("NENI pritomno v listu");
                                list.add(stat);
                                listSocketAddress.add(dpack.getSocketAddress());
                            }
                        }

                        /**
                         * Kdyz skonci spojeni, vymaz hrace
                         */
                        if(stop)
                            list.clear();
                    }
                }
            };
        thread.start();
    }

    public void receiveX()
    {

        Thread serverThread = new ServerThread(socket)
            {
                @Override
                @SuppressWarnings("unchecked")
                public void run() 
                {
                    InputStream is = null;
                    OutputStream os = null;
                    ObjectOutputStream oos = null;
                    ObjectInputStream ois = null;

                    String line = null;
                    boolean stop = false;

                    try
                    {
                        s.setTcpNoDelay(true);
                        s.setSoTimeout(2147483647);
                        is = s.getInputStream();
                        ois = new ObjectInputStream(is);
                    }
                    catch(Exception e)
                    {
                        System.out.println(e);
                        stop = true;
                    }

                    while(!stop)
                    {
                        try
                        {
                            stat = (HeroStats)(ois.readObject());
                            incommingShotList = (ArrayList<Shot>)(ois.readObject());
                            for(Shot s : incommingShotList)
                            {
                                s.serverId = idOfShot;
                                shotList.add(s);
                                idOfShot++;
                            }

                            /*for(Shot s : shotList)
                            {
                            int a = 0;
                            System.out.println(a+" shot c= " + s.c + " q= "+s.q);
                            a++;
                            }*/
                        }
                        catch (IOException e) 
                        {
                            System.out.println(e);
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("IO Error/ Client "+line+" terminated abruptly");
                            stop = true;
                        }
                        catch(NullPointerException e)
                        {
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("Client "+line+" Closed");
                            stop = true;
                        }
                        catch(Exception e)
                        {
                            System.out.println(e+"chyba je v receive");
                            stop = true;
                        }

                        boolean idFound = false;

                        synchronized(list)
                        {
                            for(int i = 0; i < list.size(); i++)
                            {
                                if(list.get(i).id == stat.id)
                                {
                                    stat.health = list.get(i).health;
                                    list.set(i, stat);
                                    idFound = true;
                                }
                            }
                            if(!idFound)
                            {
                                //System.out.println("NENI pritomno v listu");
                                list.add(stat);
                            }
                        }

                        /**
                         * Kdyz skonci spojeni, vymaz hrace
                         */
                        if(stop)
                            list.clear();
                        /*if(stop)
                        {
                        Iterator<HeroStats> it = list.iterator();
                        while (it.hasNext()) 
                        {
                        HeroStats h = it.next();
                        if (h.id == stat.id) 
                        {
                        System.out.println("id "+h.id+" bylo smazano");
                        it.remove();
                        }
                        }
                        }*/

                    }
                }
            };
        serverThread.start();
    }

    public void send()
    {
        Thread thread = new Thread()
            {
                @Override
                public void run() 
                {
                    boolean stop = false;
                    while(!stop)
                    {
                        try
                        { 
                            Thread.sleep(15);
                        }
                        catch(Exception e)
                        {
                            System.out.println(e);
                        }
                        try
                        {
                            shotList2 = new ArrayList<Shot>();
                            shotList2 = (ArrayList<Shot>)(shotList.clone());
                            byte[] buffer = gameObjectsToBytes(list, shotList2);
                            //System.out.println(buffer.length);
                            for( Iterator<SocketAddress> it = listSocketAddress.iterator(); it.hasNext() ; )
                            {
                                SocketAddress sa = it.next();
                                //System.out.println(listSocketAddress.size());
                                //System.out.println(sa);
                                dsoc.send(new DatagramPacket(buffer, buffer.length, sa));
                            }
                        }
                        catch(IOException e)
                        {
                            stop = true;
                            e.printStackTrace();
                            System.out.println("Server IO send error");
                        }
                        catch(Exception e)
                        {
                            stop = true;
                            e.printStackTrace();
                            System.out.println("Server send error");
                        }
                    }
                }
            };
        thread.start();
    }

    public void sendX()
    {
        Thread serverThread = new ServerThread(socket)
            {
                @Override
                public void run() 
                {
                    InputStream is = null;
                    OutputStream os = null;
                    ObjectOutputStream oos = null;
                    ObjectInputStream ois = null;

                    Socket s = socket;
                    String line = null;

                    HeroStats stats = null;
                    boolean stop = false;

                    try
                    {
                        s.setTcpNoDelay(true);
                        s.setSoTimeout(2147483647);
                        os = s.getOutputStream();
                        oos = new ObjectOutputStream(os);
                    }
                    catch(NullPointerException e)
                    {
                        line=this.getName(); //reused String line for getting thread name
                        System.out.println("Client "+line+" Closed");
                        stop = true;
                    }
                    catch(Exception e)
                    {
                        System.out.println(e+"chyba je v send");
                        stop = true;
                    }

                    while(!stop)
                    {
                        try
                        { 
                            Thread.sleep(15);
                        }
                        catch(Exception e)
                        {
                            System.out.println(e);
                        }

                        try
                        {
                            synchronized(list)
                            {
                                oos.writeObject(list);

                                synchronized(shotList)
                                {
                                    shotList2 = new ArrayList<Shot>();
                                    shotList2 = (ArrayList<Shot>)(shotList.clone());

                                    oos.writeObject(shotList2);
                                }

                                oos.flush();
                                oos.reset();
                            }
                        }
                        catch (IOException e) 
                        {
                            System.out.println(e);
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("IO Error/ Client "+line+" terminated abruptly");
                            stop = true;
                        }
                        catch(NullPointerException e)
                        {
                            line=this.getName(); //reused String line for getting thread name
                            System.out.println("Client "+line+" Closed");
                            stop = true;
                        }
                        catch(Exception e)
                        {
                            System.out.println(e+"chyba je v send2");
                            stop = true;
                        }
                    }
                }
            };
        serverThread.start();
    }

    public void shotMove()
    {
        for( Iterator<Shot> it = shotList.iterator(); it.hasNext() ; )
        {
            Shot tmp = it.next();
            if(tmp.isLeft)
                tmp.x -= SHOT_SPEED;
            else
                tmp.x += SHOT_SPEED;
        }
    }

    public void giveDamage(int id, int damage)
    {
        for( Iterator<HeroStats> itH = list.iterator(); itH.hasNext() ; )
        {
            HeroStats h = itH.next();
            if(id == h.id)
                h.health -= damage;
            System.out.println("ID= "+h.id+"  HP= "+h.health);
        }
    }

    public void loadMap()
    {
        // obrys
        mapList.add(new Rectangle(0, 0, 1008, 5));
        mapList.add(new Rectangle(0, 0, 5, 740));
        mapList.add(new Rectangle(0, 710, 1008, 5));
        mapList.add(new Rectangle(1008, 0, 5, 740));
        //mapList.add(new Rectangle(500, 0, 5, 740));
        //patra
        mapList.add(new Rectangle(100, 650, 250, 5));
        mapList.add(new Rectangle(200, 590, 400, 5));
    }

    public void checkShotCollisions()
    {
        ArrayList<Integer> indexToDelete = new ArrayList<Integer>();
        Rectangle shotRectangle = new Rectangle();
        for( Iterator<Shot> it = shotList.iterator(); it.hasNext() ; )
        {
            Shot s = it.next();

            //STENY, PATRA atp.
            shotRectangle = s.getRectangle();

            for(Rectangle wall : mapList)
            {
                if(shotRectangle.intersects(wall))
                {
                    indexToDelete.add(s.serverId);
                }
            }

            // PANACKOVE    
            Rectangle hero = new Rectangle();
            for( Iterator<HeroStats> itH = list.iterator(); itH.hasNext() ; )
            {
                HeroStats h = itH.next();
                hero = h.getRectangle();
                if(shotRectangle.intersects(hero))
                {
                    if(h.id != s.id)
                    {
                        indexToDelete.add(s.serverId);
                        giveDamage(h.id, s.damage);
                        //h.health -= s.damage;
                    }
                }
            }
        }
        for(int del : indexToDelete)
        {
            for( Iterator<Shot> iter = shotList.iterator(); iter.hasNext() ; )
            {
                Shot delShot = iter.next();
                if(delShot.serverId == del)
                {
                    iter.remove();
                }

            }
        }
        shotList2 = shotList; //concurent exception... o_O

        //System.out.println("incomingshotlist- "+incommingShotList.size()+" shotlist2 "+shotList2.size()+" shotlist1- "+shotList.size()+" list- "+list.size()+" maplist- "+mapList.size()+" INDEx to delete- "+indexToDelete.size());

    }

    public byte[] gameObjectsToBytes(ArrayList<HeroStats> stats, ArrayList<Shot> shots) throws Exception
    {
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        ObjectOutput out = null;
        byte[] bytes;
        try 
        {
            out = new ObjectOutputStream(bos);   
            out.writeObject(stats);
            out.writeObject(shots);
            bytes = bos.toByteArray();
        } 
        finally 
        {
            try {
                if (out != null) {
                    out.close();
                }
            } catch (IOException ex) {
                // ignore close exception
            }
            try {
                bos.close();
            } catch (IOException ex) {
                // ignore close exception
            }
        }
        return bytes;
    } 

    class ServerThread extends Thread
    {
        Socket s;
        public ServerThread(Socket s)
        {
            this.s = s;
        }

        public void run()
        {

        }

    }

}
