import java.net.*;
import java.io.*;
import java.util.*;

class UDPClientServer
{
    public static DatagramSocket dsoc;

    public void client() throws Exception
    {
        dsoc = new DatagramSocket(4446);
        InetAddress host = InetAddress.getByName("192.168.1.150");

        String str = "Server ti prikazuje napsat SLOVO";
        byte buffer[] = str.getBytes();   
        dsoc.send(new DatagramPacket(buffer, buffer.length, host, 4445));

        byte buff[] = new byte[1024];
        DatagramPacket dpack = new DatagramPacket(buff,buff.length);
        dsoc.receive(dpack);

        HeroStats test = neco(buff);
        System.out.println(test.health);
    }

    public byte[] toBytes(int i)
    {
        byte[] result = new byte[4];

        result[0] = (byte) (i >> 24);
        result[1] = (byte) (i >> 16);
        result[2] = (byte) (i >> 8);
        result[3] = (byte) (i /*>> 0*/);

        return result;
    }

    public HeroStats neco(byte[] buffer) throws Exception
    {
        ByteArrayInputStream bis = new ByteArrayInputStream(buffer);
        ObjectInput in = null;
        HeroStats stat;
        try {
            in = new ObjectInputStream(bis);
            stat = (HeroStats)(in.readObject()); 
        } 
        finally {
            try {
                bis.close();
            } catch (IOException ex) {
                // ignore close exception
            }
            try {
                if (in != null) {
                    in.close();
                }
            } catch (IOException ex) {
                // ignore close exception
            }
        }
        return stat;
    }

}